#include <string>
#include <vector>

class Chain
{
protected:
    std::vector<const class Encoding* > chain;
public:
    void AddEncoding(const std::string& s);
};

class ChainOut: public Chain
{
public:
    const std::string Encode(const std::wstring& s) const;
};

class ChainIn: public Chain
{
public:
    const std::wstring Decode(const std::string& s) const;
};

struct Chain2
{
    ChainIn in;
    ChainOut out;
};

/* Throws chainname if chain2 is not defined */
const Chain2& FindChain2(const std::string& chainname);

const Chain2 CreateBuiltinChain(const std::string& encname);
